## What is Verbose?

Verbose is a post splitter for Mastodon in a web page. You can write or paste a long post into it, set some options, push the “Split” button, and you get your long post split into many posts considering [Mastodon rules](https://docs.joinmastodon.org/user/posting/#text): every http(s) link counts as 23 characters and every mention counts only for the length of its username part. Each split post will come with `…` signs where it makes sense and a counter in `[n/t]` form, where `n` is the current post number and `t` is the total posts number.

You can connect Verbose to your account: this way *you’ll be able to post all split posts at once directly from within Verbose*, they will be automatically “chain posted” (the second will be a reply to the first, the third to the second, and so on) and, before posting them, you may set their visibility, language, and a post to reply to with the first split post.

You can also use it without connecting it to your account, but after splitting your long post you’ll have to copy and paste by hand each split post in sequence into Mastodon, and “chain posting” will be up to you.

Verbose doesn’t save anywhere what you write or paste into it, it doesn’t use third parties’ cookies, it sets some cookies of its own only if you choose to connect it to your account, and it can be used even without Javascript.

If you find issues please let me know [here](https://git.lattuga.net/pongrebio/verbose/issues), or using the e-mail address you can find in my profile page, or directly contacting [me on Mastodon](https://puntarella.party/@umpi).

## Setting up Verbose on a webserver

To set up Verbose on a webserver you need it to support PHP, you have to make the directory you put Verbose into and its `/js` subdirectory writeable to the user your webserver runs under, and you have to set a `conf.ini` file into Verbose main directory.

The `conf.ini` file *must* define a `webservertimeout` in seconds, i.e. the maximum time in seconds your webserver allows a request to last (with Apache it’s [this](https://httpd.apache.org/docs/current/mod/core.html#timeout)); for example:

```
webservertimeout=120
```

Inside `conf.ini` you can also customize the “link text” (text Verbose can add to last split post if there’s enough space left; by default it’s `[This post was split using https://git.lattuga.net/pongrebio/verbose]`); for example:

```
link=[This post was split using https://my.server/verbose]
```

Of course you can put anything as a value for `link`, but the UI mentions it as «link to this page», so it’s expected to contain a link to the URL of your running Verbose instance ;-)

You can also set a `footer` that, if defined, will be added before the link to this repo in the page footer; for example:

```
footer=<a href="https://my.server/">Home</a>
```

## Are there running Verbose instances?

You can find a running Verbose instance [here](https://mastodon.help/verbose).

If you set up your own and you want it to be listed here, please let me know using the e-mail address you can find in my profile page, or directly contacting [me on Mastodon](https://puntarella.party/@umpi).
